Index: /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearDiscriminantAnalysis.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearDiscriminantAnalysis.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearDiscriminantAnalysis.cs	(revision 5733)
@@ -90,7 +90,7 @@
       ISymbolicExpressionTree tree = new SymbolicExpressionTree(new ProgramRootSymbol().CreateTreeNode());
       ISymbolicExpressionTreeNode startNode = new StartSymbol().CreateTreeNode();
-      tree.Root.AddSubTree(startNode);
+      tree.Root.AddSubtree(startNode);
       ISymbolicExpressionTreeNode addition = new Addition().CreateTreeNode();
-      startNode.AddSubTree(addition);
+      startNode.AddSubtree(addition);
 
       int col = 0;
@@ -99,5 +99,5 @@
         vNode.VariableName = column;
         vNode.Weight = w[col];
-        addition.AddSubTree(vNode);
+        addition.AddSubtree(vNode);
         col++;
       }
@@ -105,5 +105,5 @@
       ConstantTreeNode cNode = (ConstantTreeNode)new Constant().CreateTreeNode();
       cNode.Value = w[w.Length - 1];
-      addition.AddSubTree(cNode);
+      addition.AddSubtree(cNode);
 
 
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Algorithms.DataAnalysis/3.4/Linear/LinearRegression.cs	(revision 5733)
@@ -94,7 +94,7 @@
       ISymbolicExpressionTree tree = new SymbolicExpressionTree(new ProgramRootSymbol().CreateTreeNode());
       ISymbolicExpressionTreeNode startNode = new StartSymbol().CreateTreeNode();
-      tree.Root.AddSubTree(startNode);
+      tree.Root.AddSubtree(startNode);
       ISymbolicExpressionTreeNode addition = new Addition().CreateTreeNode();
-      startNode.AddSubTree(addition);
+      startNode.AddSubtree(addition);
 
       int col = 0;
@@ -103,5 +103,5 @@
         vNode.VariableName = column;
         vNode.Weight = coefficients[col];
-        addition.AddSubTree(vNode);
+        addition.AddSubtree(vNode);
         col++;
       }
@@ -109,5 +109,5 @@
       ConstantTreeNode cNode = (ConstantTreeNode)new Constant().CreateTreeNode();
       cNode.Value = coefficients[coefficients.Length - 1];
-      addition.AddSubTree(cNode);
+      addition.AddSubtree(cNode);
 
       SymbolicRegressionSolution solution = new SymbolicRegressionSolution(new SymbolicRegressionModel(tree, new SymbolicDataAnalysisExpressionTreeInterpreter()), problemData);
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.Views/3.4/SymbolicExpressionTreeChart.cs	(revision 5733)
@@ -263,5 +263,5 @@
 
       //draw terminal node
-      if (node.SubTrees.Count() == 0) {
+      if (node.Subtrees.Count() == 0) {
         graphics.FillRectangle(nodeFillBrush, visualTreeNode.X, visualTreeNode.Y, visualTreeNode.Width, visualTreeNode.Height);
         graphics.DrawRectangle(nodeLinePen, visualTreeNode.X, visualTreeNode.Y, visualTreeNode.Width, visualTreeNode.Height);
@@ -281,9 +281,9 @@
       //calculate areas for the subtrees according to their tree size and call drawFunctionTree
       Point connectFrom = new Point(visualTreeNode.X + visualTreeNode.Width / 2, visualTreeNode.Y + visualTreeNode.Height);
-      int[] xBoundaries = new int[node.SubTrees.Count() + 1];
+      int[] xBoundaries = new int[node.Subtrees.Count() + 1];
       xBoundaries[0] = x;
-      for (int i = 0; i < node.SubTrees.Count(); i++) {
-        xBoundaries[i + 1] = (int)(xBoundaries[i] + (width * (double)node.SubTrees.ElementAt(i).GetLength()) / (node.GetLength() - 1));
-        DrawFunctionTree(node.SubTrees.ElementAt(i), graphics, xBoundaries[i], y + height,
+      for (int i = 0; i < node.Subtrees.Count(); i++) {
+        xBoundaries[i + 1] = (int)(xBoundaries[i] + (width * (double)node.Subtrees.ElementAt(i).GetLength()) / (node.GetLength() - 1));
+        DrawFunctionTree(node.Subtrees.ElementAt(i), graphics, xBoundaries[i], y + height,
           xBoundaries[i + 1] - xBoundaries[i], height, connectFrom);
       }
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentCreater.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentCreater.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentCreater.cs	(revision 5733)
@@ -124,6 +124,6 @@
       // the branch at the cut point is to be replaced by a new argument node
       var cutPoints = (from node in defunBranch.IterateNodesPrefix()
-                       where node.SubTrees.Count() > 0
-                       from subtree in node.SubTrees
+                       where node.Subtrees.Count() > 0
+                       from subtree in node.Subtrees
                        select new CutPoint(node, subtree)).ToList();
 
@@ -134,6 +134,6 @@
       // replace the branch at the cut point with an argument node
       var replacedBranch = selectedCutPoint.Child;
-      selectedCutPoint.Parent.RemoveSubTree(selectedCutPoint.ChildIndex);
-      selectedCutPoint.Parent.InsertSubTree(selectedCutPoint.ChildIndex, newArgumentNode);
+      selectedCutPoint.Parent.RemoveSubtree(selectedCutPoint.ChildIndex);
+      selectedCutPoint.Parent.InsertSubtree(selectedCutPoint.ChildIndex, newArgumentNode);
 
       // find all old invocations of the selected ADF and attach a cloned version of the replaced branch (with all argument-nodes expanded)
@@ -141,5 +141,5 @@
       var invocationNodes = (from node in tree.IterateNodesPostfix().OfType<InvokeFunctionTreeNode>()
                              where node.Symbol.FunctionName == defunBranch.FunctionName
-                             where node.SubTrees.Count() == defunBranch.NumberOfArguments
+                             where node.Subtrees.Count() == defunBranch.NumberOfArguments
                              select node).ToList();
       // do this repeatedly until no matching invocations are found      
@@ -148,9 +148,9 @@
         foreach (var invocationNode in invocationNodes) {
           // check that the invocation node really has the correct number of arguments
-          if (invocationNode.SubTrees.Count() != defunBranch.NumberOfArguments) throw new InvalidOperationException();
+          if (invocationNode.Subtrees.Count() != defunBranch.NumberOfArguments) throw new InvalidOperationException();
           // append a new argument branch after expanding all argument nodes
           var clonedBranch = (ISymbolicExpressionTreeNode)replacedBranch.Clone();
-          clonedBranch = ReplaceArgumentsInBranch(clonedBranch, invocationNode.SubTrees);
-          invocationNode.InsertSubTree(newArgumentNode.Symbol.ArgumentIndex, clonedBranch);
+          clonedBranch = ReplaceArgumentsInBranch(clonedBranch, invocationNode.Subtrees);
+          invocationNode.InsertSubtree(newArgumentNode.Symbol.ArgumentIndex, clonedBranch);
           newlyAddedBranches.Add(clonedBranch);
         }
@@ -159,5 +159,5 @@
                            from node in newlyAddedBranch.IterateNodesPostfix().OfType<InvokeFunctionTreeNode>()
                            where node.Symbol.FunctionName == defunBranch.FunctionName
-                           where node.SubTrees.Count() == defunBranch.NumberOfArguments
+                           where node.Subtrees.Count() == defunBranch.NumberOfArguments
                            select node).ToList();
       }
@@ -173,5 +173,5 @@
           defunBranch.Grammar.AddAllowedChildSymbol(symb, newArgumentNode.Symbol, i);
         }
-      foreach (var subtree in tree.Root.SubTrees) {
+      foreach (var subtree in tree.Root.Subtrees) {
         // when the changed function is known in the branch then update the number of arguments
         var matchingSymbol = subtree.Grammar.Symbols.OfType<InvokeFunction>().Where(s => s.FunctionName == defunBranch.FunctionName).SingleOrDefault();
@@ -196,8 +196,8 @@
       } else {
         // call recursively for all subtree
-        List<ISymbolicExpressionTreeNode> subtrees = new List<ISymbolicExpressionTreeNode>(branch.SubTrees);
-        while (branch.SubTrees.Count() > 0) branch.RemoveSubTree(0);
+        List<ISymbolicExpressionTreeNode> subtrees = new List<ISymbolicExpressionTreeNode>(branch.Subtrees);
+        while (branch.Subtrees.Count() > 0) branch.RemoveSubtree(0);
         foreach (var subtree in subtrees) {
-          branch.AddSubTree(ReplaceArgumentsInBranch(subtree, argumentTrees));
+          branch.AddSubtree(ReplaceArgumentsInBranch(subtree, argumentTrees));
         }
         return branch;
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDeleter.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDeleter.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDeleter.cs	(revision 5733)
@@ -71,5 +71,5 @@
                              select node).ToList();
       foreach (var invokeNode in invocationNodes) {
-        invokeNode.RemoveSubTree(removedArgument);
+        invokeNode.RemoveSubtree(removedArgument);
       }
 
@@ -81,5 +81,5 @@
       selectedDefunBranch.NumberOfArguments--;
       // reduce arity in known functions of all root branches
-      foreach (var subtree in symbolicExpressionTree.Root.SubTrees) {
+      foreach (var subtree in symbolicExpressionTree.Root.Subtrees) {
         var matchingInvokeSymbol = subtree.Grammar.Symbols.OfType<InvokeFunction>().Where(s => s.FunctionName == selectedDefunBranch.FunctionName).SingleOrDefault();
         if (matchingInvokeSymbol != null) {
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDuplicater.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDuplicater.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/ArgumentDuplicater.cs	(revision 5733)
@@ -86,5 +86,5 @@
       var invocationNodes = (from node in symbolicExpressionTree.IterateNodesPrefix().OfType<InvokeFunctionTreeNode>()
                              where node.Symbol.FunctionName == selectedDefunBranch.FunctionName
-                             where node.SubTrees.Count() == selectedDefunBranch.NumberOfArguments
+                             where node.Subtrees.Count() == selectedDefunBranch.NumberOfArguments
                              select node).ToList();
       // do this repeatedly until no matching invocations are found      
@@ -93,8 +93,8 @@
         foreach (var invokeNode in invocationNodes) {
           // check that the invocation node really has the correct number of arguments
-          if (invokeNode.SubTrees.Count() != selectedDefunBranch.NumberOfArguments) throw new InvalidOperationException();
-          var argumentBranch = invokeNode.GetSubTree(selectedArgumentSymbol.ArgumentIndex);
+          if (invokeNode.Subtrees.Count() != selectedDefunBranch.NumberOfArguments) throw new InvalidOperationException();
+          var argumentBranch = invokeNode.GetSubtree(selectedArgumentSymbol.ArgumentIndex);
           var clonedArgumentBranch = (ISymbolicExpressionTreeNode)argumentBranch.Clone();
-          invokeNode.InsertSubTree(newArgumentIndex, clonedArgumentBranch);
+          invokeNode.InsertSubtree(newArgumentIndex, clonedArgumentBranch);
           newlyAddedBranches.Add(clonedArgumentBranch);
         }
@@ -102,5 +102,5 @@
                            from node in newlyAddedBranch.IterateNodesPrefix().OfType<InvokeFunctionTreeNode>()
                            where node.Symbol.FunctionName == selectedDefunBranch.FunctionName
-                           where node.SubTrees.Count() == selectedDefunBranch.NumberOfArguments
+                           where node.Subtrees.Count() == selectedDefunBranch.NumberOfArguments
                            select node).ToList();
       }
@@ -116,5 +116,5 @@
 
       // increase the arity of the changed ADF in all branches that can use this ADF
-      foreach (var subtree in symbolicExpressionTree.Root.SubTrees) {
+      foreach (var subtree in symbolicExpressionTree.Root.Subtrees) {
         var matchingInvokeSymbol = (from symb in subtree.Grammar.Symbols.OfType<InvokeFunction>()
                                     where symb.FunctionName == selectedDefunBranch.FunctionName
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineCreater.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineCreater.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineCreater.cs	(revision 5733)
@@ -95,5 +95,5 @@
 
       // select a random body (either the result producing branch or an ADF branch)
-      var bodies = from node in symbolicExpressionTree.Root.SubTrees
+      var bodies = from node in symbolicExpressionTree.Root.Subtrees
                    select new { Tree = node, Length = node.GetLength() };
       var totalNumberOfBodyNodes = bodies.Select(x => x.Length).Sum();
@@ -111,5 +111,5 @@
       // select a random cut point in the selected branch
       var allCutPoints = (from parent in selectedBody.IterateNodesPrefix()
-                          from subtree in parent.SubTrees
+                          from subtree in parent.Subtrees
                           select new CutPoint(parent, subtree)).ToList();
       if (allCutPoints.Count() == 0)
@@ -122,19 +122,19 @@
       ISymbolicExpressionTreeNode functionBody = selectedCutPoint.Child;
       // disconnect the function body from the tree
-      selectedCutPoint.Parent.RemoveSubTree(selectedCutPoint.ChildIndex);
+      selectedCutPoint.Parent.RemoveSubtree(selectedCutPoint.ChildIndex);
       // disconnect the argument branches from the function
       functionBody = DisconnectBranches(functionBody, argumentCutPoints);
       // insert a function invocation symbol instead
       var invokeNode = (InvokeFunctionTreeNode)(new InvokeFunction(newFunctionName)).CreateTreeNode();
-      selectedCutPoint.Parent.InsertSubTree(selectedCutPoint.ChildIndex, invokeNode);
+      selectedCutPoint.Parent.InsertSubtree(selectedCutPoint.ChildIndex, invokeNode);
       // add the branches selected as argument as subtrees of the function invocation node
       foreach (var argumentCutPoint in argumentCutPoints)
-        invokeNode.AddSubTree(argumentCutPoint.Child);
+        invokeNode.AddSubtree(argumentCutPoint.Child);
 
       // insert a new function defining branch
       var defunNode = (DefunTreeNode)(new Defun()).CreateTreeNode();
       defunNode.FunctionName = newFunctionName;
-      defunNode.AddSubTree(functionBody);
-      symbolicExpressionTree.Root.AddSubTree(defunNode);
+      defunNode.AddSubtree(functionBody);
+      symbolicExpressionTree.Root.AddSubtree(defunNode);
       // the grammar in the newly defined function is a clone of the grammar of the originating branch
       defunNode.SetGrammar((ISymbolicExpressionTreeGrammar)selectedBody.Grammar.Clone());
@@ -157,5 +157,5 @@
       if (selectedBody.Symbol is Defun) {
         var originalFunctionDefinition = selectedBody as DefunTreeNode;
-        foreach (var subtree in symbolicExpressionTree.Root.SubTrees) {
+        foreach (var subtree in symbolicExpressionTree.Root.Subtrees) {
           var originalBranchInvokeSymbol = (from symb in subtree.Grammar.Symbols.OfType<InvokeFunction>()
                                             where symb.FunctionName == originalFunctionDefinition.FunctionName
@@ -177,9 +177,9 @@
       }
       // remove the subtrees so that we can clone only the root node
-      List<ISymbolicExpressionTreeNode> subtrees = new List<ISymbolicExpressionTreeNode>(node.SubTrees);
-      while (node.SubTrees.Count() > 0) node.RemoveSubTree(0);
+      List<ISymbolicExpressionTreeNode> subtrees = new List<ISymbolicExpressionTreeNode>(node.Subtrees);
+      while (node.Subtrees.Count() > 0) node.RemoveSubtree(0);
       // recursively apply function for subtrees or append a argument terminal node
       foreach (var subtree in subtrees) {
-        node.AddSubTree(DisconnectBranches(subtree, argumentCutPoints));
+        node.AddSubtree(DisconnectBranches(subtree, argumentCutPoints));
       }
       return node;
@@ -198,5 +198,5 @@
       } else {
         // get the number of argument nodes (which must be cut-off) in the sub-trees
-        var numberOfArgumentsInSubtrees = (from subtree in selectedRoot.SubTrees
+        var numberOfArgumentsInSubtrees = (from subtree in selectedRoot.Subtrees
                                            let nArgumentsInTree = subtree.IterateNodesPrefix().OfType<ArgumentTreeNode>().Count()
                                            select nArgumentsInTree).ToList();
@@ -209,10 +209,10 @@
         }
         // cut-off in the sub-trees in random order
-        var randomIndexes = (from index in Enumerable.Range(0, selectedRoot.SubTrees.Count())
+        var randomIndexes = (from index in Enumerable.Range(0, selectedRoot.Subtrees.Count())
                              select new { Index = index, OrderValue = random.NextDouble() })
                              .OrderBy(x => x.OrderValue)
                              .Select(x => x.Index);
         foreach (var subtreeIndex in randomIndexes) {
-          var subtree = selectedRoot.GetSubTree(subtreeIndex);
+          var subtree = selectedRoot.GetSubtree(subtreeIndex);
           minNewArgumentsForSubtrees[subtreeIndex] = 0;
           // => cut-off at 0..n points somewhere in the current sub-tree
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDeleter.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDeleter.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDeleter.cs	(revision 5733)
@@ -62,9 +62,9 @@
       var selectedDefunBranch = functionDefiningBranches.SelectRandom(random);
       // remove the selected defun
-      int defunSubtreeIndex = symbolicExpressionTree.Root.IndexOfSubTree(selectedDefunBranch);
-      symbolicExpressionTree.Root.RemoveSubTree(defunSubtreeIndex);
+      int defunSubtreeIndex = symbolicExpressionTree.Root.IndexOfSubtree(selectedDefunBranch);
+      symbolicExpressionTree.Root.RemoveSubtree(defunSubtreeIndex);
 
       // remove references to deleted function
-      foreach (var subtree in symbolicExpressionTree.Root.SubTrees.OfType<SymbolicExpressionTreeTopLevelNode>()) {
+      foreach (var subtree in symbolicExpressionTree.Root.Subtrees.OfType<SymbolicExpressionTreeTopLevelNode>()) {
         var matchingInvokeSymbol = (from symb in subtree.Grammar.Symbols.OfType<InvokeFunction>()
                                     where symb.FunctionName == selectedDefunBranch.FunctionName
@@ -84,5 +84,5 @@
       // the invocations below it are removed already
       var invocationCutPoint = (from node in symbolicExpressionTree.IterateNodesPrefix()
-                                from subtree in node.SubTrees.OfType<InvokeFunctionTreeNode>()
+                                from subtree in node.Subtrees.OfType<InvokeFunctionTreeNode>()
                                 where subtree.Symbol.FunctionName == selectedDefunBranch.FunctionName
                                 select new CutPoint(node, subtree)).FirstOrDefault();
@@ -101,11 +101,11 @@
         if (replacementTree.HasLocalParameters)
           replacementTree.ResetLocalParameters(random);
-        invocationCutPoint.Parent.RemoveSubTree(invocationCutPoint.ChildIndex);
-        invocationCutPoint.Parent.InsertSubTree(invocationCutPoint.ChildIndex, replacementTree);
+        invocationCutPoint.Parent.RemoveSubtree(invocationCutPoint.ChildIndex);
+        invocationCutPoint.Parent.InsertSubtree(invocationCutPoint.ChildIndex, replacementTree);
 
         ProbabilisticTreeCreator.PTC2(random, replacementTree, maxLength, maxDepth);
 
         invocationCutPoint = (from node in symbolicExpressionTree.IterateNodesPrefix()
-                              from subtree in node.SubTrees.OfType<InvokeFunctionTreeNode>()
+                              from subtree in node.Subtrees.OfType<InvokeFunctionTreeNode>()
                               where subtree.Symbol.FunctionName == selectedDefunBranch.FunctionName
                               select new CutPoint(node, subtree)).FirstOrDefault();
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDuplicater.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDuplicater.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/ArchitectureManipulators/SubroutineDuplicater.cs	(revision 5733)
@@ -71,8 +71,8 @@
       string newFunctionName = allowedFunctionNames.Except(UsedFunctionNames(symbolicExpressionTree)).First();
       duplicatedDefunBranch.FunctionName = newFunctionName;
-      symbolicExpressionTree.Root.AddSubTree(duplicatedDefunBranch);
+      symbolicExpressionTree.Root.AddSubtree(duplicatedDefunBranch);
       duplicatedDefunBranch.SetGrammar((ISymbolicExpressionTreeGrammar)selectedBranch.Grammar.Clone());
       // add an invoke symbol for each branch that is allowed to invoke the original function
-      foreach (var subtree in symbolicExpressionTree.Root.SubTrees.OfType<SymbolicExpressionTreeTopLevelNode>()) {
+      foreach (var subtree in symbolicExpressionTree.Root.Subtrees.OfType<SymbolicExpressionTreeTopLevelNode>()) {
         var matchingInvokeSymbol = (from symb in subtree.Grammar.Symbols.OfType<InvokeFunction>()
                                     where symb.FunctionName == selectedBranch.FunctionName
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Compiler/SymbolicExpressionTreeCompiler.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Compiler/SymbolicExpressionTreeCompiler.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Compiler/SymbolicExpressionTreeCompiler.cs	(revision 5733)
@@ -33,5 +33,5 @@
       entryPoint.Clear();
       // compile main body branches
-      foreach (var branch in tree.Root.GetSubTree(0).SubTrees) {
+      foreach (var branch in tree.Root.GetSubtree(0).Subtrees) {
         code.AddRange(Compile(branch, opCodeMapper));
       }
@@ -43,5 +43,5 @@
         if (code.Count > ushort.MaxValue) throw new ArgumentException("Code for the tree is too long (> ushort.MaxValue).");
         entryPoint[branch.FunctionName] = (ushort)code.Count;
-        code.AddRange(Compile(branch.GetSubTree(0), opCodeMapper));
+        code.AddRange(Compile(branch.GetSubtree(0), opCodeMapper));
       }
       // address of all functions is fixed now
@@ -62,7 +62,7 @@
       foreach (var node in branch.IterateNodesPrefix()) {
         Instruction instr = new Instruction();
-        int subTreesCount = node.SubTrees.Count();
-        if (subTreesCount > 255) throw new ArgumentException("Number of subtrees is too big (>255)");
-        instr.nArguments = (byte)subTreesCount;
+        int subtreesCount = node.SubtreesCount;
+        if (subtreesCount > 255) throw new ArgumentException("Number of subtrees is too big (>255)");
+        instr.nArguments = (byte)subtreesCount;
         instr.opCode = opCodeMapper(node);
         if (node.Symbol is Argument) {
Index: /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Creators/ProbabilisticTreeCreator.cs
===================================================================
--- /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Creators/ProbabilisticTreeCreator.cs	(revision 5732)
+++ /branches/DataAnalysis Refactoring/HeuristicLab.Encodings.SymbolicExpressionTreeEncoding/3.4/Creators/ProbabilisticTreeCreator.cs	(revision 5733)
@@ -89,5 +89,5 @@
       startNode.SetGrammar(new SymbolicExpressionTreeGrammar(grammar));
       if (startNode.HasLocalParameters) startNode.ResetLocalParameters(random);
-      rootNode.AddSubTree(startNode);
+      rootNode.AddSubtree(startNode);
       PTC2(random, startNode, maxTreeLength, maxTreeDepth);
       tree.Root = rootNode;
@@ -120,5 +120,5 @@
         } else {
           // clean seedNode
-          while (seedNode.SubTrees.Count() > 0) seedNode.RemoveSubTree(0);
+          while (seedNode.Subtrees.Count() > 0) seedNode.RemoveSubtree(0);
         }
         // try a different length MAX_TRIES times
@@ -138,5 +138,5 @@
         // insert a dummy sub-tree and add the pending extension to the list
         var dummy = new SymbolicExpressionTreeNode();
-        root.AddSubTree(dummy);
+        root.AddSubtree(dummy);
         extensionPoints.Add(new TreeExtensionPoint { Parent = root, ChildIndex = i, ExtensionPointDepth = 0 });
       }
@@ -162,6 +162,6 @@
           ISymbolicExpressionTreeNode newTree = selectedSymbol.CreateTreeNode();
           if (newTree.HasLocalParameters) newTree.ResetLocalParameters(random);
-          parent.RemoveSubTree(argumentIndex);
-          parent.InsertSubTree(argumentIndex, newTree);
+          parent.RemoveSubtree(argumentIndex);
+          parent.InsertSubtree(argumentIndex, newTree);
 
           var topLevelNode = newTree as SymbolicExpressionTreeTopLevelNode;
@@ -177,5 +177,5 @@
             // insert a dummy sub-tree and add the pending extension to the list
             var dummy = new SymbolicExpressionTreeNode();
-            newTree.AddSubTree(dummy);
+            newTree.AddSubtree(dummy);
             extensionPoints.Add(new TreeExtensionPoint { Parent = newTree, ChildIndex = i, ExtensionPointDepth = extensionDepth + 1 });
           }
@@ -207,6 +207,6 @@
       var tree = selectedSymbol.CreateTreeNode();
       if (tree.HasLocalParameters) tree.ResetLocalParameters(random);
-      parent.RemoveSubTree(childIndex);
-      parent.InsertSubTree(childIndex, tree);
+      parent.RemoveSubtree(childIndex);
+      parent.InsertSubtree(childIndex, tree);
 
       var topLevelNode = tree as SymbolicExpressionTreeTopLevelNode;
@@ -217,5 +217,5 @@
         // insert a dummy sub-tree and add the pending extension to the list
         var dummy = new SymbolicExpressionTreeNode();
-        tree.AddSubTree(dummy);
+        tree.AddSubtree(dummy);
         // replace the just inserted dummy by recursive application
         ReplaceWithMinimalTree(random, root, tree, i);
